/*!\file: Observations.h
 * \brief prototypes for Observations.h
 */ 

#ifndef _CONTAINER_OBSERVATIONS_H_
#define  _CONTAINER_OBSERVATIONS_H_

class Obsevration;
class Quadtree;

class Observations: public DataSet{

	private:
		Quadtree* quadtree;
		double    coefficient; //For integer coordinate conversion
		double    xmin;
		double    ymin;
		double    xmax;
		double    ymax;

	public:

		/*constructors, destructors*/
		Observations();
		Observations(double* observations_list,double* x,double* y,int n);
		~Observations();

		/*Methods*/
		void ObservationList(double **px,double **py,double **pobs,int* pnobs,double x_interp,double y_interp);
		void QuadtreeColoring(double* A,double *x,double *y,int n);

};
#endif //ifndef _OBSERVATIONS_H_

